#include <iostream>
#include <fstream>
#include <string>
#include <typeinfo>
#include <math.h>
#include <sys/time.h>
#include <stdlib.h>


using namespace std;


#define type float // type of main array elements
#define LENGTH 1024 // default length of array
#define MY_RAND_MAX 10 // for rand value of scalars
#define NUM_THREADS 8 // default number of threads

#define CACHE_ANNIL (2*1024*1024) // size of array for cache spoiling
#define ITERS 100 // number of iterations for more precise time counting


void printArr(int length, type *a, type *b, int len1, type *c, int len2, type *x, int len3, bool file = false) {
	
	
	ofstream fout("res_A.txt",ios::out);

	cout << "a: ";
	for (int i = 0; i < length; i++) {
		cout << a[i] << " ";
		if (file) fout << a[i]<< " ";
	}
	cout << endl;
	if (file) fout << endl;

	cout << "b: ";
	for (int i = 0; i < len1; i++) {
                cout << b[i] << " ";
        }
        cout << endl;

	cout << "c: ";
	for (int i = 0; i < len2; i++) {
                cout << c[i] << " ";
        }
        cout << endl;

	cout << "x: ";
        for (int i = 0; i < len3; i++) {
                cout << x[i] << " ";
        }
        cout << endl;

}


static int count_time = 1;
// this function is responsible for creating new array with random elements
type* create_array(int length) {

	if (length == 1) {
		type *tmp = new type[1];
		tmp[0] = (type)1/((rand()%MY_RAND_MAX)+2); // if type=int, here will be 0
                if (tmp[0] == 0) tmp[0] = (type)((rand()%MY_RAND_MAX)+1); // if int, tmp will be some int between 1 and length
		return tmp;
	}

	// if length != 1
	type* arr = new type[length];

	srand(time(NULL)*count_time);
	count_time++;
	type tmp_elem = 0;
	int i;
	for (i = 0; i < length; i++) {
		tmp_elem = (type)1/(i+2); // if type=int, here will be 0
		if (tmp_elem == 0) tmp_elem = (type)(i+1); // if int, tmp will be some int between 1 and length
		arr[i] = tmp_elem;
	}
	
	return arr;
}

// reads array from file and returns pointer to the array and its length 
void read_array(type *b, type *c, type *x, string filename, int len1, int len2, int len3) {

	type* arr;

	ifstream fin(filename.c_str(),ios::in);
        if (!fin) {
                printf("Wrong file name!\n");
		arr = new type[1];
		arr[0] = -1;
		b = arr;
		c = arr;
		x = arr;
        }
	ofstream fout("../triada_results.txt", ios::app | ios::out);
	// reading 3 arrays: b,c,x from filename
	int length = 0, i = 0;
	fin >> length;
	if (len1 != length) { cout << "Error with length of B array!" << endl; fout << "Error with length of B array!" << endl; exit(-1); }
        for (i = 0; i < length; i++){
                b[i] = 0;
                //while ( ((ch=fgetc(fd))>='0') && (ch<='9')) {
		if (!fin.eof()) {
			fin >> b[i];
		} 
	}

	fin >> length;
        if (len2 != length) { cout << "Error with length of C array!" << endl; fout << "Error with length of C array!" << endl; exit(-1); }
        for (i = 0; i < length; i++){
                c[i] = 0;
                //while ( ((ch=fgetc(fd))>='0') && (ch<='9')) {
                if (!fin.eof()) {
                        fin >> c[i];
                }
        }

	fin >> length;
        if (len3 != length) { cout << "Error with length of X array!" << endl; fout << "Error with length of X array!" << endl; exit(-1); }
        for (i = 0; i < length; i++){
                x[i] = 0;
                //while ( ((ch=fgetc(fd))>='0') && (ch<='9')) {
                if (!fin.eof()) {
                        fin >> x[i];
                }
        }

	fout.close();
}

//////////////////////
/**** Start here ****/
//////////////////////
int main(int argc, char** argv) {


	if ((argc > 5)) {
		cout << "Wrong number of parameters!" << endl;
		return -1;
	}
	int length = LENGTH;
	type elem_min = 0;
	type elem_max = 1;
	int i;
	int len_set = 0, min_set = 0, max_set = 0;
	int num_threads = NUM_THREADS;
	int create_arr = 1;
	string proc_type = "clovertown1";
	for (i = 1; i < argc; i++) {
		switch(argv[i][0]) {
			case 'l': {
				length = atoi(&(argv[i][1]));
                                length = round(pow((double)2,length));
				len_set = 1;
				break;
			}
			case 'm': {
				elem_min = atoi(&(argv[i][1]));
				min_set = 1;
				break;
			}
			case 'M': {
				elem_max = atoi(&(argv[i][1]));
				max_set = 1;
				break;
			}
			case 't': {
				num_threads = atoi(&(argv[i][1]));
				break;
			}
			case '-': {
				switch (argv[i][1]) {
					case 'r': {
						create_arr = 0;
						break;
					}
					case '-': {
						proc_type = argv[i]+2*sizeof(char); // +2 - skips first 2 elements
						break;
					}
				}
				break;
			}
		}
	}
	// end of reading input parameters

	if (length <= 0) {
		cout << length << endl;
		cout << "Wrong value for length!" << endl;
		return -1;
	}

	if (elem_max <= elem_min) {
		cout << "Minimum should be less than maximum!" << endl;
		return -1;
	}
	if (num_threads < 0) {
		cout << "Wrong value for number of threads!" << endl;
		return -1;
	}

	// getting performance of processor type
	double peak = 0;
	if (!proc_type.compare("clovertown1")) peak = 6.4;
	if (!proc_type.compare("clovertown2")) peak = 9.32;
	if (!proc_type.compare("clovertown3")) peak = 10.64;
        if (!proc_type.compare("woodcrest2")) peak = 10.64;
        if (!proc_type.compare("woodcrest3")) peak = 10.64;
	if (!proc_type.compare("woodcrest5")) peak = 12;
	if (!proc_type.compare("woodcrest6")) peak = 8;
	//if (!proc_type.compare("woodcrest7")) peak = 8;
	//if (!proc_type.compare("pentium41")) peak = 6;
	//if (!proc_type.compare("pentiumd1")) peak = 6.8;
	if (!proc_type.compare("xeon1")) peak = 6.4;
	if (!proc_type.compare("dempsey1")) peak = 6;
	if (!proc_type.compare("opteron3")) peak = 4.8;
	if (!proc_type.compare("opteron4")) peak = 3.6;
	if (!proc_type.compare("opteron5")) peak = 3.6;
	if (!proc_type.compare("barcelona1")) peak = 8.8;
        //if (!proc_type.compare("harpertown")) peak = ;
        //if (!proc_type.compare("nehalem")) peak = ;

	// end of checks

	// writing into csv file
	// at very first iteration I want to write info about testing
	bool new_csv_file = false;
	ifstream fin("../csv_res.csv",ios:: in);
	if (!fin.is_open()) { // if there is no such file
		new_csv_file = true;
	}
	fin.close();

        ofstream fres("../csv_res.csv", ios::app | ios::out); // file with kpd results in csv format
        if (length == 2) { // if it's all for this processor, writing endl
                fres << " Processor type: " << proc_type.c_str() << endl;
                return 0;
        }


	string filename = "arr.txt";


	// main variables that are used in algorithm itself
	/////// !!!if changes with arrays and scalars, uncomment necessary declarations;
	type* a = new type[length];

	type* b = new type[length]; int len1 = length;
        //type* b = new type[1]; int len1 = 1;
	//type* c = new type[length]; int len2 = length;
       	type* c = new type[1]; int len2 = 1;
	//type* x = new type[length]; int len3 = length;
        type* x = new type[1]; int len3 = 1;

	type sc_x = 0, sc_b = 0, sc_c = 0;
	// end of main variables

	struct timeval st,en,bef,gain;
	gettimeofday(&bef,NULL);
	// read arrays from file or create new arrays


	for (i = 0 ; i < length; i++) a[i] = 0;

	if (create_arr) { // here we create new arrays
		b = create_array(len1);
		c = create_array(len2);
		x = create_array(len3);
		sc_x = x[0]; sc_b = b[0]; sc_c = c[0];
	}
	else { // here we use existing arrays, from "arr.txt" file
		read_array(b,c,x,filename,len1,len2,len3);
		sc_x = x[0], sc_b = b[0]; sc_c = c[0];
	}
	// printArr(length,a,b,c,x);

	// service variables for main part
	int helper = 0;
	int j;
	double taken_time = 0;
	for (j = 0; j < ITERS; j++) {

		helper = 0;
		int *cache_annil;
		cache_annil = new int[CACHE_ANNIL];		
		cache_annil[0] = 0;
		for (i = 1; i < CACHE_ANNIL; i++) {
                	cache_annil[i] = j-i;
			helper += cache_annil[i-1];
		}
		delete cache_annil;
		if ((j%10) == 0) cout << "j: " << j << endl;
		/***************************/
		/**** main part is here ****/
		/***************************/
		gettimeofday(&st,NULL); // gets start time
		for (i = 0; i < length; i++) 
			{
				// you should change here between arrays and scalars
				a[i] = b[i]*sc_x + sc_c;
			}
		
		gettimeofday(&en,NULL);
		/***************************/
		/****  main part ends   ****/
		/***************************/
		if ((taken_time > ((en.tv_sec-st.tv_sec)+(en.tv_usec-st.tv_usec)/1000000.0)) || (j == 0)) {
			taken_time = ((en.tv_sec-st.tv_sec)+(en.tv_usec-st.tv_usec)/1000000.0);
		}

		//gain.tv_sec += (en.tv_sec-st.tv_sec);
		//gain.tv_usec += (en.tv_usec-st.tv_usec);
	}
	cout << endl;
	cout << "helper: " << helper << endl;
	ofstream fout("../triada_results.txt", ios::app | ios::out);

//	double taken_time = ((gain.tv_sec) + (gain.tv_usec)/1000000.0)/ITERS;
	taken_time = taken_time*10000; // because in seconds it will be too small
	string s;
	if (create_arr) s = "creating random ";
	else s = "reading ";
	// write into file
	cout << "-----------------------------------------------------" << endl;
        cout << "Sequential, time taken: " << taken_time << " --------" << endl;
        cout << "-----------------------------------------------------" << endl;
	cout << "Processor type: " << proc_type.c_str() << endl;
        //fout << "Time taken on " << s << "array: " << ((st.tv_sec-bef.tv_sec) + (st.tv_usec-bef.tv_usec)/1000000.0) << endl;
        cout << "Length: " << length << endl;
	// should write about b,c,x - which is array and which is scalar
	string bS,cS,xS;
	if (len1 == 1) bS = "B - scalar; ";
	else bS = "B - array; ";
        if (len2 == 1) cS = "C - scalar; ";
        else cS = "C - array; ";
        if (len3 == 1) xS = "X - scalar.";
        else xS = "X - array.";
	cout << bS.c_str() << cS.c_str() << xS.c_str() << endl;
	// write type of elements of array
	cout << "Element type: " << typeid(type).name() << endl;
	// write peak and real performance
	double kpd = ((2*length)/taken_time)/(peak*1000);
	cout << "length: " << length << "; taken_time: " << taken_time << "; peak: " << peak << endl; 
	cout << "KPD: " << kpd << "%" << endl;
/*
	if (new_csv_file) { // look after check block to understand meaning of new_csv_file
		fres << "Without indirect addressing" << endl;
		fres << bS.c_str() << cS.c_str() << xS.c_str() << endl;
		fres << "Element type: " << typeid(type).name() << endl;
	}
	fres << kpd << ";";
*/
	//fout << typeName(type) << endl;
	cout << "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" << endl << endl;

	/*
	for (i = 0; i < length; i++) {
		cout << a[i] << " ";
	}
	cout << endl << endl;
        for (i = 0; i < len1; i++) {
                cout << b[i] << " ";
        }
        cout << endl << endl;
        for (i = 0; i < len2; i++) {
                cout << c[i] << " ";
        }
        cout << endl << endl;
        for (i = 0; i < len3; i++) {
                cout << x[i] << " ";
        }
        cout << endl << endl;
	*/


	//printArr(length,a,b,len1,c,len2,x,len3,true);

	return 0;
}
